<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.10.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>MeLOn: melon::FeedForwardNet&lt; T &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="MeLOn_only.png"/></td>
  <td id="projectalign">
   <div id="projectname">MeLOn
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.10.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('classmelon_1_1_feed_forward_net.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-static-methods">Static Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classmelon_1_1_feed_forward_net-members.html">List of all members</a>  </div>
  <div class="headertitle"><div class="title">melon::FeedForwardNet&lt; T &gt; Class Template Reference</div></div>
</div><!--header-->
<div class="contents">

<p>This class represents a feed foward artificial network to be used in the MAiNGO solver.  
 <a href="#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="ff_net_8h_source.html">ffNet.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for melon::FeedForwardNet&lt; T &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classmelon_1_1_feed_forward_net.png" usemap="#melon::FeedForwardNet_3C_20T_20_3E_map" alt=""/>
  <map id="melon::FeedForwardNet_3C_20T_20_3E_map" name="melon::FeedForwardNet_3C_20T_20_3E_map">
<area href="classmelon_1_1_melon_model.html" alt="melon::MelonModel&lt; T &gt;" shape="rect" coords="0,0,178,24"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-methods" name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a40d5999e0803420f02e2285aee4d7f19" id="r_a40d5999e0803420f02e2285aee4d7f19"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a40d5999e0803420f02e2285aee4d7f19">FeedForwardNet</a> ()</td></tr>
<tr class="memdesc:a40d5999e0803420f02e2285aee4d7f19"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor for creating object with no model loaded.  <br /></td></tr>
<tr class="separator:a40d5999e0803420f02e2285aee4d7f19"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac1ac26b7d389470fc0a13463cddd9a3f" id="r_ac1ac26b7d389470fc0a13463cddd9a3f"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#ac1ac26b7d389470fc0a13463cddd9a3f">FeedForwardNet</a> (std::string modelName, <a class="el" href="namespacemelon.html#a4304be33fc99f22bd328db5774394531">MODEL_FILE_TYPE</a> fileType)</td></tr>
<tr class="memdesc:ac1ac26b7d389470fc0a13463cddd9a3f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor for creating object from file with the modelName relative to the current working directory.  <br /></td></tr>
<tr class="separator:ac1ac26b7d389470fc0a13463cddd9a3f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa5bfb8592ff40db349c0699f22dcaf6e" id="r_aa5bfb8592ff40db349c0699f22dcaf6e"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#aa5bfb8592ff40db349c0699f22dcaf6e">FeedForwardNet</a> (std::string modelPath, std::string modelName, <a class="el" href="namespacemelon.html#a4304be33fc99f22bd328db5774394531">MODEL_FILE_TYPE</a> fileType)</td></tr>
<tr class="memdesc:aa5bfb8592ff40db349c0699f22dcaf6e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor for creating object from file with the modelName being relative to modelPath.  <br /></td></tr>
<tr class="separator:aa5bfb8592ff40db349c0699f22dcaf6e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5aa1638cb722f3139dd95f229d0ba0a2" id="r_a5aa1638cb722f3139dd95f229d0ba0a2"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a5aa1638cb722f3139dd95f229d0ba0a2">FeedForwardNet</a> (std::shared_ptr&lt; <a class="el" href="structmelon_1_1_ann_data.html">AnnData</a> &gt; modelData)</td></tr>
<tr class="memdesc:a5aa1638cb722f3139dd95f229d0ba0a2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor for creating object from existing <a class="el" href="structmelon_1_1_ann_data.html" title="struct containing all information regarding the structure of a feedforward neural network">AnnData</a> object.  <br /></td></tr>
<tr class="separator:a5aa1638cb722f3139dd95f229d0ba0a2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a30df96721f1c57e57ed668676f18d9dc" id="r_a30df96721f1c57e57ed668676f18d9dc"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a30df96721f1c57e57ed668676f18d9dc">~FeedForwardNet</a> ()=default</td></tr>
<tr class="memdesc:a30df96721f1c57e57ed668676f18d9dc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default Destructor.  <br /></td></tr>
<tr class="separator:a30df96721f1c57e57ed668676f18d9dc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aee07aaae68255e370ba1e82c01229cdd" id="r_aee07aaae68255e370ba1e82c01229cdd"><td class="memItemLeft" align="right" valign="top">std::vector&lt; T &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#aee07aaae68255e370ba1e82c01229cdd">calculate_prediction_reduced_space</a> (const std::vector&lt; T &gt; input)</td></tr>
<tr class="memdesc:aee07aaae68255e370ba1e82c01229cdd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculates the prediction of the feed forward net for a given point in reduced space mode (only values network inputs are given)  <br /></td></tr>
<tr class="separator:aee07aaae68255e370ba1e82c01229cdd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1bbcf42c9cb486f063d8a47722c7a209" id="r_a1bbcf42c9cb486f063d8a47722c7a209"><td class="memItemLeft" align="right" valign="top">std::vector&lt; T &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a1bbcf42c9cb486f063d8a47722c7a209">calculate_prediction_full_space</a> (const std::vector&lt; T &gt; input, const std::vector&lt; T &gt; internalVariables, std::vector&lt; T &gt; &amp;constraints)</td></tr>
<tr class="memdesc:a1bbcf42c9cb486f063d8a47722c7a209"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculates the prediction of the feed forward net for a given point in full space mode (values for all internal variables are given and a set of constraints is returned)  <br /></td></tr>
<tr class="separator:a1bbcf42c9cb486f063d8a47722c7a209"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a577ee52dca91fe4d987484afa8bf33a8" id="r_a577ee52dca91fe4d987484afa8bf33a8"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a577ee52dca91fe4d987484afa8bf33a8">set_tanh_formulation</a> (const <a class="el" href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45">TANH_REFORMULATION</a> &amp;reformulation)</td></tr>
<tr class="memdesc:a577ee52dca91fe4d987484afa8bf33a8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Changes the reformulation to be used for tanh evaluations. The reformulations are intended to be used when solvers do not support the tanh function. As reformulations change the tightness of the McCormick envelopes when used with MAiNGO it is recommended to use the standard tanh whenever possible.  <br /></td></tr>
<tr class="separator:a577ee52dca91fe4d987484afa8bf33a8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a47ce1749d5969289495ad8a84e438c70" id="r_a47ce1749d5969289495ad8a84e438c70"><td class="memItemLeft" align="right" valign="top">unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a47ce1749d5969289495ad8a84e438c70">get_number_of_full_space_variables</a> ()</td></tr>
<tr class="memdesc:a47ce1749d5969289495ad8a84e438c70"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the number of internal network variables.  <br /></td></tr>
<tr class="separator:a47ce1749d5969289495ad8a84e438c70"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9a6336300c3e798cb58832019e701bc4" id="r_a9a6336300c3e798cb58832019e701bc4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a9a6336300c3e798cb58832019e701bc4">get_full_space_variables</a> (unsigned int &amp;variableNumber, std::vector&lt; std::string &gt; &amp;variableNames, std::vector&lt; std::pair&lt; double, double &gt; &gt; &amp;variableBounds)</td></tr>
<tr class="memdesc:a9a6336300c3e798cb58832019e701bc4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the number and the names of the internal variables of the network.  <br /></td></tr>
<tr class="separator:a9a6336300c3e798cb58832019e701bc4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classmelon_1_1_melon_model"><td colspan="2" onclick="javascript:dynsection.toggleInherit('pub_methods_classmelon_1_1_melon_model')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classmelon_1_1_melon_model.html">melon::MelonModel&lt; T &gt;</a></td></tr>
<tr class="memitem:a1c7f4a28d7a34e48a93b9899a66204b0 inherit pub_methods_classmelon_1_1_melon_model" id="r_a1c7f4a28d7a34e48a93b9899a66204b0"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_melon_model.html#a1c7f4a28d7a34e48a93b9899a66204b0">~MelonModel</a> ()=default</td></tr>
<tr class="memdesc:a1c7f4a28d7a34e48a93b9899a66204b0 inherit pub_methods_classmelon_1_1_melon_model"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default destructor.  <br /></td></tr>
<tr class="separator:a1c7f4a28d7a34e48a93b9899a66204b0 inherit pub_methods_classmelon_1_1_melon_model"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9acb78ea183bc6bf583540efcef58a0b inherit pub_methods_classmelon_1_1_melon_model" id="r_a9acb78ea183bc6bf583540efcef58a0b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_melon_model.html#a9acb78ea183bc6bf583540efcef58a0b">load_model</a> (std::string modelName, <a class="el" href="namespacemelon.html#a4304be33fc99f22bd328db5774394531">MODEL_FILE_TYPE</a> fileType)</td></tr>
<tr class="memdesc:a9acb78ea183bc6bf583540efcef58a0b inherit pub_methods_classmelon_1_1_melon_model"><td class="mdescLeft">&#160;</td><td class="mdescRight">Loads new model from file.  <br /></td></tr>
<tr class="separator:a9acb78ea183bc6bf583540efcef58a0b inherit pub_methods_classmelon_1_1_melon_model"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae002de8e7c020adfcad49ce7e050066e inherit pub_methods_classmelon_1_1_melon_model" id="r_ae002de8e7c020adfcad49ce7e050066e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_melon_model.html#ae002de8e7c020adfcad49ce7e050066e">load_model</a> (std::string modelPath, std::string modelName, <a class="el" href="namespacemelon.html#a4304be33fc99f22bd328db5774394531">MODEL_FILE_TYPE</a> fileType)</td></tr>
<tr class="memdesc:ae002de8e7c020adfcad49ce7e050066e inherit pub_methods_classmelon_1_1_melon_model"><td class="mdescLeft">&#160;</td><td class="mdescRight">Loads new model from file.  <br /></td></tr>
<tr class="separator:ae002de8e7c020adfcad49ce7e050066e inherit pub_methods_classmelon_1_1_melon_model"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a37fb378f8eabbcfdb7db707dbfa04a26 inherit pub_methods_classmelon_1_1_melon_model" id="r_a37fb378f8eabbcfdb7db707dbfa04a26"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_melon_model.html#a37fb378f8eabbcfdb7db707dbfa04a26">load_model</a> (std::shared_ptr&lt; const <a class="el" href="struct_model_data.html">ModelData</a> &gt; modelData)</td></tr>
<tr class="memdesc:a37fb378f8eabbcfdb7db707dbfa04a26 inherit pub_methods_classmelon_1_1_melon_model"><td class="mdescLeft">&#160;</td><td class="mdescRight">Loads new model from file.  <br /></td></tr>
<tr class="separator:a37fb378f8eabbcfdb7db707dbfa04a26 inherit pub_methods_classmelon_1_1_melon_model"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pri-methods" name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:a52bc8b4239937c6290e3a2b59dad9f24" id="r_a52bc8b4239937c6290e3a2b59dad9f24"><td class="memItemLeft" align="right" valign="top">std::vector&lt; T &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a52bc8b4239937c6290e3a2b59dad9f24">_calculate_layer_activation</a> (const std::vector&lt; T &gt; &amp;v, const <a class="el" href="namespacemelon.html#a48f12885945641a41597e6668940dc73">ACTIVATION_FUNCTION</a> activationFunction)</td></tr>
<tr class="memdesc:a52bc8b4239937c6290e3a2b59dad9f24"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculates the activations for a layer given its inputs.  <br /></td></tr>
<tr class="separator:a52bc8b4239937c6290e3a2b59dad9f24"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a863db6c1f3e0937db86ecbb59cacf635" id="r_a863db6c1f3e0937db86ecbb59cacf635"><td class="memItemLeft" align="right" valign="top">std::vector&lt; T &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a863db6c1f3e0937db86ecbb59cacf635">_calculate_prediction</a> (const std::vector&lt; T &gt; input, const std::vector&lt; T &gt; internalVariables, const bool fullSpace, std::vector&lt; T &gt; &amp;constraints)</td></tr>
<tr class="memdesc:a863db6c1f3e0937db86ecbb59cacf635"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculates the prediction of the feed forward net for a given point.  <br /></td></tr>
<tr class="separator:a863db6c1f3e0937db86ecbb59cacf635"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae98f7e952148f9d8aa22d2450f50f9db" id="r_ae98f7e952148f9d8aa22d2450f50f9db"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#ae98f7e952148f9d8aa22d2450f50f9db">_set_data_object</a> (std::shared_ptr&lt; const <a class="el" href="struct_model_data.html">ModelData</a> &gt; modelData) override</td></tr>
<tr class="memdesc:ae98f7e952148f9d8aa22d2450f50f9db"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets data object containing model parameters.  <br /></td></tr>
<tr class="separator:ae98f7e952148f9d8aa22d2450f50f9db"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pri-static-methods" name="pri-static-methods"></a>
Static Private Member Functions</h2></td></tr>
<tr class="memitem:acc52bba26e3affaf5bd8bdd97367130f" id="r_acc52bba26e3affaf5bd8bdd97367130f"><td class="memItemLeft" align="right" valign="top">static T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#acc52bba26e3affaf5bd8bdd97367130f">_tanh</a> (T x)</td></tr>
<tr class="separator:acc52bba26e3affaf5bd8bdd97367130f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa827bc95b61702119170c403edb86f9c" id="r_aa827bc95b61702119170c403edb86f9c"><td class="memItemLeft" align="right" valign="top">static T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#aa827bc95b61702119170c403edb86f9c">_tanh_reformulation_1</a> (T x)</td></tr>
<tr class="separator:aa827bc95b61702119170c403edb86f9c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af2ce30b35e0450243cdcc4f77649b9a7" id="r_af2ce30b35e0450243cdcc4f77649b9a7"><td class="memItemLeft" align="right" valign="top">static T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#af2ce30b35e0450243cdcc4f77649b9a7">_tanh_reformulation_2</a> (T x)</td></tr>
<tr class="separator:af2ce30b35e0450243cdcc4f77649b9a7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa135bf5d528c1b99a63f0cf3ddceb7ac" id="r_aa135bf5d528c1b99a63f0cf3ddceb7ac"><td class="memItemLeft" align="right" valign="top">static T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#aa135bf5d528c1b99a63f0cf3ddceb7ac">_tanh_reformulation_3</a> (T x)</td></tr>
<tr class="separator:aa135bf5d528c1b99a63f0cf3ddceb7ac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac33420287de3773a2ab4dfab022287cf" id="r_ac33420287de3773a2ab4dfab022287cf"><td class="memItemLeft" align="right" valign="top">static T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#ac33420287de3773a2ab4dfab022287cf">_tanh_reformulation_4</a> (T x)</td></tr>
<tr class="separator:ac33420287de3773a2ab4dfab022287cf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a81e55a0f8f437563f86d3e896c1db9c0" id="r_a81e55a0f8f437563f86d3e896c1db9c0"><td class="memItemLeft" align="right" valign="top">static T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a81e55a0f8f437563f86d3e896c1db9c0">_relu</a> (T x)</td></tr>
<tr class="separator:a81e55a0f8f437563f86d3e896c1db9c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab7ba2a702f03f392778f7d05a43ce356" id="r_ab7ba2a702f03f392778f7d05a43ce356"><td class="memItemLeft" align="right" valign="top">static T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#ab7ba2a702f03f392778f7d05a43ce356">_relu6</a> (T x)</td></tr>
<tr class="separator:ab7ba2a702f03f392778f7d05a43ce356"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pri-attribs" name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a3b6e46ca8afad6af62b3f15e2b6b5ec6" id="r_a3b6e46ca8afad6af62b3f15e2b6b5ec6"><td class="memItemLeft" align="right" valign="top">std::shared_ptr&lt; const <a class="el" href="structmelon_1_1_ann_data.html">AnnData</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a3b6e46ca8afad6af62b3f15e2b6b5ec6">_annData</a></td></tr>
<tr class="separator:a3b6e46ca8afad6af62b3f15e2b6b5ec6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8d22eb1e65b7f74b4e84c3c8ea78df51" id="r_a8d22eb1e65b7f74b4e84c3c8ea78df51"><td class="memItemLeft" align="right" valign="top">std::unique_ptr&lt; <a class="el" href="classmelon_1_1_scaler.html">Scaler</a>&lt; T &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a8d22eb1e65b7f74b4e84c3c8ea78df51">_inputScaler</a></td></tr>
<tr class="separator:a8d22eb1e65b7f74b4e84c3c8ea78df51"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a25f7c656e140792b73fccc7058249256" id="r_a25f7c656e140792b73fccc7058249256"><td class="memItemLeft" align="right" valign="top">std::unique_ptr&lt; <a class="el" href="classmelon_1_1_scaler.html">Scaler</a>&lt; T &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a25f7c656e140792b73fccc7058249256">_outputScaler</a></td></tr>
<tr class="separator:a25f7c656e140792b73fccc7058249256"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa29c58f20ab3b344243565940fc0e243" id="r_aa29c58f20ab3b344243565940fc0e243"><td class="memItemLeft" align="right" valign="top">T(*&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#aa29c58f20ab3b344243565940fc0e243">_tanh_formulation</a> )(T) = &amp;<a class="el" href="#acc52bba26e3affaf5bd8bdd97367130f">_tanh</a></td></tr>
<tr class="separator:aa29c58f20ab3b344243565940fc0e243"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="inherited" name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_methods_classmelon_1_1_melon_model"><td colspan="2" onclick="javascript:dynsection.toggleInherit('pro_methods_classmelon_1_1_melon_model')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classmelon_1_1_melon_model.html">melon::MelonModel&lt; T &gt;</a></td></tr>
<tr class="memitem:a0877da878cabba96d129b5e2540b9eca inherit pro_methods_classmelon_1_1_melon_model" id="r_a0877da878cabba96d129b5e2540b9eca"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_melon_model.html#a0877da878cabba96d129b5e2540b9eca">MelonModel</a> (std::shared_ptr&lt; <a class="el" href="classmelon_1_1_model_parser_factory.html">ModelParserFactory</a> &gt; parserFactory)</td></tr>
<tr class="memdesc:a0877da878cabba96d129b5e2540b9eca inherit pro_methods_classmelon_1_1_melon_model"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <br /></td></tr>
<tr class="separator:a0877da878cabba96d129b5e2540b9eca inherit pro_methods_classmelon_1_1_melon_model"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab783bd628a80774149c34f0e2b8f8f48 inherit pro_methods_classmelon_1_1_melon_model" id="r_ab783bd628a80774149c34f0e2b8f8f48"><td class="memTemplParams" colspan="2">template&lt;typename RandomAccessIterator &gt; </td></tr>
<tr class="memitem:ab783bd628a80774149c34f0e2b8f8f48 inherit pro_methods_classmelon_1_1_melon_model"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classmelon_1_1_melon_model.html#ab783bd628a80774149c34f0e2b8f8f48">_set_constraints</a> (std::vector&lt; T &gt; &amp;constraints, std::vector&lt; T &gt; &amp;constraintEvaluation, RandomAccessIterator &amp;constraintValue) const</td></tr>
<tr class="memdesc:ab783bd628a80774149c34f0e2b8f8f48 inherit pro_methods_classmelon_1_1_melon_model"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets constraints required for fullspace opimization.  <br /></td></tr>
<tr class="separator:ab783bd628a80774149c34f0e2b8f8f48 inherit pro_methods_classmelon_1_1_melon_model"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7b1045b2b3c48d7e89042abbf042184e inherit pro_methods_classmelon_1_1_melon_model" id="r_a7b1045b2b3c48d7e89042abbf042184e"><td class="memTemplParams" colspan="2">template&lt;typename RandomAccessIterator &gt; </td></tr>
<tr class="memitem:a7b1045b2b3c48d7e89042abbf042184e inherit pro_methods_classmelon_1_1_melon_model"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classmelon_1_1_melon_model.html#a7b1045b2b3c48d7e89042abbf042184e">_set_constraints</a> (std::vector&lt; T &gt; &amp;constraints, T &amp;constraintEvaluation, RandomAccessIterator &amp;constraintValue) const</td></tr>
<tr class="memdesc:a7b1045b2b3c48d7e89042abbf042184e inherit pro_methods_classmelon_1_1_melon_model"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets constraints required for fullspace opimization.  <br /></td></tr>
<tr class="separator:a7b1045b2b3c48d7e89042abbf042184e inherit pro_methods_classmelon_1_1_melon_model"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_attribs_classmelon_1_1_melon_model"><td colspan="2" onclick="javascript:dynsection.toggleInherit('pro_attribs_classmelon_1_1_melon_model')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="classmelon_1_1_melon_model.html">melon::MelonModel&lt; T &gt;</a></td></tr>
<tr class="memitem:a17ac3b399c0615c5e4033f532e8cc7c4 inherit pro_attribs_classmelon_1_1_melon_model" id="r_a17ac3b399c0615c5e4033f532e8cc7c4"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_melon_model.html#a17ac3b399c0615c5e4033f532e8cc7c4">_modelLoaded</a> { false }</td></tr>
<tr class="separator:a17ac3b399c0615c5e4033f532e8cc7c4 inherit pro_attribs_classmelon_1_1_melon_model"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a79a4a98914ebfc91398a20b9014726e1 inherit pro_attribs_classmelon_1_1_melon_model" id="r_a79a4a98914ebfc91398a20b9014726e1"><td class="memItemLeft" align="right" valign="top">std::shared_ptr&lt; <a class="el" href="classmelon_1_1_model_parser_factory.html">ModelParserFactory</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_melon_model.html#a79a4a98914ebfc91398a20b9014726e1">_parserFactory</a></td></tr>
<tr class="separator:a79a4a98914ebfc91398a20b9014726e1 inherit pro_attribs_classmelon_1_1_melon_model"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><div class="compoundTemplParams">template&lt;typename T&gt;<br />
class melon::FeedForwardNet&lt; T &gt;</div><p>This class represents a feed foward artificial network to be used in the MAiNGO solver. </p>
<p>This class is used to enable the solution of optimization problems in MAiNGO containing feed foward ANNs. The trained ANNs can be loaded from csv/xml files created in matlab/keras. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a40d5999e0803420f02e2285aee4d7f19" name="a40d5999e0803420f02e2285aee4d7f19"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a40d5999e0803420f02e2285aee4d7f19">&#9670;&#160;</a></span>FeedForwardNet() <span class="overload">[1/4]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::FeedForwardNet </td>
          <td>(</td>
          <td class="paramname"><span class="paramname"></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Constructor for creating object with no model loaded. </p>

</div>
</div>
<a id="ac1ac26b7d389470fc0a13463cddd9a3f" name="ac1ac26b7d389470fc0a13463cddd9a3f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac1ac26b7d389470fc0a13463cddd9a3f">&#9670;&#160;</a></span>FeedForwardNet() <span class="overload">[2/4]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::FeedForwardNet </td>
          <td>(</td>
          <td class="paramtype">std::string</td>          <td class="paramname"><span class="paramname"><em>modelName</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespacemelon.html#a4304be33fc99f22bd328db5774394531">MODEL_FILE_TYPE</a></td>          <td class="paramname"><span class="paramname"><em>fileType</em></span>&#160;)</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Constructor for creating object from file with the modelName relative to the current working directory. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">modelName</td><td>is the name of the network</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">fileType</td><td>specifies the data format of the network file </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aa5bfb8592ff40db349c0699f22dcaf6e" name="aa5bfb8592ff40db349c0699f22dcaf6e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa5bfb8592ff40db349c0699f22dcaf6e">&#9670;&#160;</a></span>FeedForwardNet() <span class="overload">[3/4]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::FeedForwardNet </td>
          <td>(</td>
          <td class="paramtype">std::string</td>          <td class="paramname"><span class="paramname"><em>modelPath</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string</td>          <td class="paramname"><span class="paramname"><em>modelName</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespacemelon.html#a4304be33fc99f22bd328db5774394531">MODEL_FILE_TYPE</a></td>          <td class="paramname"><span class="paramname"><em>fileType</em></span>&#160;)</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Constructor for creating object from file with the modelName being relative to modelPath. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">modelPath</td><td>is the path to the directory in which the network is located</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">modelName</td><td>is the name of the network</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">fileType</td><td>specifies the data format of the network file </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a5aa1638cb722f3139dd95f229d0ba0a2" name="a5aa1638cb722f3139dd95f229d0ba0a2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5aa1638cb722f3139dd95f229d0ba0a2">&#9670;&#160;</a></span>FeedForwardNet() <span class="overload">[4/4]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::FeedForwardNet </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="structmelon_1_1_ann_data.html">AnnData</a> &gt;</td>          <td class="paramname"><span class="paramname"><em>modelData</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Constructor for creating object from existing <a class="el" href="structmelon_1_1_ann_data.html" title="struct containing all information regarding the structure of a feedforward neural network">AnnData</a> object. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">modelData</td><td>is a <a class="el" href="structmelon_1_1_ann_data.html" title="struct containing all information regarding the structure of a feedforward neural network">AnnData</a> object containing the data which defines the network </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a30df96721f1c57e57ed668676f18d9dc" name="a30df96721f1c57e57ed668676f18d9dc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a30df96721f1c57e57ed668676f18d9dc">&#9670;&#160;</a></span>~FeedForwardNet()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::~<a class="el" href="classmelon_1_1_feed_forward_net.html">FeedForwardNet</a> </td>
          <td>(</td>
          <td class="paramname"><span class="paramname"></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Default Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a52bc8b4239937c6290e3a2b59dad9f24" name="a52bc8b4239937c6290e3a2b59dad9f24"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a52bc8b4239937c6290e3a2b59dad9f24">&#9670;&#160;</a></span>_calculate_layer_activation()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt; T &gt; <a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::_calculate_layer_activation </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; T &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>v</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespacemelon.html#a48f12885945641a41597e6668940dc73">ACTIVATION_FUNCTION</a></td>          <td class="paramname"><span class="paramname"><em>activationFunction</em></span>&#160;)</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Calculates the activations for a layer given its inputs. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">v</td><td>is a vector containing the summed inputs for each neuron in the layer</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">activationFunction</td><td>is an enum that determines which activation function should be applied to the layer</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns a vector containing the activation for each neuron in the layer </dd></dl>

</div>
</div>
<a id="a863db6c1f3e0937db86ecbb59cacf635" name="a863db6c1f3e0937db86ecbb59cacf635"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a863db6c1f3e0937db86ecbb59cacf635">&#9670;&#160;</a></span>_calculate_prediction()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt; T &gt; <a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::_calculate_prediction </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; T &gt;</td>          <td class="paramname"><span class="paramname"><em>input</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; T &gt;</td>          <td class="paramname"><span class="paramname"><em>internalVariables</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const bool</td>          <td class="paramname"><span class="paramname"><em>fullSpace</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::vector&lt; T &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>constraints</em></span>&#160;)</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Calculates the prediction of the feed forward net for a given point. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">input</td><td>is a vector containing input variables based on which the network is evaluated</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">internalVariables</td><td>is a vector containing values for the internal variables of the Network</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">fullSpace</td><td>indicates wether the network should be evaluated in fullspace mode (all internal variables are pre-set and given in variables and a vector of constraints is returned)</td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">constraints</td><td>is a vector of constraints which are the difference of the given (in the vector variables) and calulated internal network variables.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns a vector containing the network output values for the given input </dd></dl>

</div>
</div>
<a id="a81e55a0f8f437563f86d3e896c1db9c0" name="a81e55a0f8f437563f86d3e896c1db9c0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a81e55a0f8f437563f86d3e896c1db9c0">&#9670;&#160;</a></span>_relu()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static T <a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::_relu </td>
          <td>(</td>
          <td class="paramtype">T</td>          <td class="paramname"><span class="paramname"><em>x</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="ab7ba2a702f03f392778f7d05a43ce356" name="ab7ba2a702f03f392778f7d05a43ce356"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab7ba2a702f03f392778f7d05a43ce356">&#9670;&#160;</a></span>_relu6()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static T <a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::_relu6 </td>
          <td>(</td>
          <td class="paramtype">T</td>          <td class="paramname"><span class="paramname"><em>x</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="ae98f7e952148f9d8aa22d2450f50f9db" name="ae98f7e952148f9d8aa22d2450f50f9db"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae98f7e952148f9d8aa22d2450f50f9db">&#9670;&#160;</a></span>_set_data_object()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::_set_data_object </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; const <a class="el" href="struct_model_data.html">ModelData</a> &gt;</td>          <td class="paramname"><span class="paramname"><em>modelData</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">private</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets data object containing model parameters. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">modelData</td><td>is a <a class="el" href="struct_model_data.html" title="Abstract class from which specific model data object can be derived and enabling polymorphism.">ModelData</a> object containing the data which defines the model </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classmelon_1_1_melon_model.html#ae1d72d9bbe5993be3d9230395abc0310">melon::MelonModel&lt; T &gt;</a>.</p>

</div>
</div>
<a id="acc52bba26e3affaf5bd8bdd97367130f" name="acc52bba26e3affaf5bd8bdd97367130f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acc52bba26e3affaf5bd8bdd97367130f">&#9670;&#160;</a></span>_tanh()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static T <a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::_tanh </td>
          <td>(</td>
          <td class="paramtype">T</td>          <td class="paramname"><span class="paramname"><em>x</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="aa827bc95b61702119170c403edb86f9c" name="aa827bc95b61702119170c403edb86f9c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa827bc95b61702119170c403edb86f9c">&#9670;&#160;</a></span>_tanh_reformulation_1()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static T <a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::_tanh_reformulation_1 </td>
          <td>(</td>
          <td class="paramtype">T</td>          <td class="paramname"><span class="paramname"><em>x</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="af2ce30b35e0450243cdcc4f77649b9a7" name="af2ce30b35e0450243cdcc4f77649b9a7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af2ce30b35e0450243cdcc4f77649b9a7">&#9670;&#160;</a></span>_tanh_reformulation_2()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static T <a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::_tanh_reformulation_2 </td>
          <td>(</td>
          <td class="paramtype">T</td>          <td class="paramname"><span class="paramname"><em>x</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="aa135bf5d528c1b99a63f0cf3ddceb7ac" name="aa135bf5d528c1b99a63f0cf3ddceb7ac"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa135bf5d528c1b99a63f0cf3ddceb7ac">&#9670;&#160;</a></span>_tanh_reformulation_3()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static T <a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::_tanh_reformulation_3 </td>
          <td>(</td>
          <td class="paramtype">T</td>          <td class="paramname"><span class="paramname"><em>x</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="ac33420287de3773a2ab4dfab022287cf" name="ac33420287de3773a2ab4dfab022287cf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac33420287de3773a2ab4dfab022287cf">&#9670;&#160;</a></span>_tanh_reformulation_4()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static T <a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::_tanh_reformulation_4 </td>
          <td>(</td>
          <td class="paramtype">T</td>          <td class="paramname"><span class="paramname"><em>x</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a1bbcf42c9cb486f063d8a47722c7a209" name="a1bbcf42c9cb486f063d8a47722c7a209"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1bbcf42c9cb486f063d8a47722c7a209">&#9670;&#160;</a></span>calculate_prediction_full_space()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt; T &gt; <a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::calculate_prediction_full_space </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; T &gt;</td>          <td class="paramname"><span class="paramname"><em>input</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; T &gt;</td>          <td class="paramname"><span class="paramname"><em>internalVariables</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::vector&lt; T &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>constraints</em></span>&#160;)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Calculates the prediction of the feed forward net for a given point in full space mode (values for all internal variables are given and a set of constraints is returned) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">input</td><td>is a vector containing input values for which the network is evaluated</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">internalVariables</td><td>is a vector containing values for the internal variables of the Network</td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">constraints</td><td>is a vector containing all intermediate variables</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns a vector containing the network output values for the given input </dd></dl>

</div>
</div>
<a id="aee07aaae68255e370ba1e82c01229cdd" name="aee07aaae68255e370ba1e82c01229cdd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aee07aaae68255e370ba1e82c01229cdd">&#9670;&#160;</a></span>calculate_prediction_reduced_space()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt; T &gt; <a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::calculate_prediction_reduced_space </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; T &gt;</td>          <td class="paramname"><span class="paramname"><em>input</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Calculates the prediction of the feed forward net for a given point in reduced space mode (only values network inputs are given) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">input</td><td>is a vector containing input values for which the network is evaluated</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns a vector containing the network output values for the given input </dd></dl>

</div>
</div>
<a id="a9a6336300c3e798cb58832019e701bc4" name="a9a6336300c3e798cb58832019e701bc4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9a6336300c3e798cb58832019e701bc4">&#9670;&#160;</a></span>get_full_space_variables()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::get_full_space_variables </td>
          <td>(</td>
          <td class="paramtype">unsigned int &amp;</td>          <td class="paramname"><span class="paramname"><em>variableNumber</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::vector&lt; std::string &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>variableNames</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::vector&lt; std::pair&lt; double, double &gt; &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>variableBounds</em></span>&#160;)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns the number and the names of the internal variables of the network. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[out]</td><td class="paramname">variableNumber</td><td>is the number of internal network variables</td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">variableNames</td><td>is a vector containing the names of all internal network variables</td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">variableBounds</td><td>is a vector of pairs containing the bounds of the internal variables </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a47ce1749d5969289495ad8a84e438c70" name="a47ce1749d5969289495ad8a84e438c70"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a47ce1749d5969289495ad8a84e438c70">&#9670;&#160;</a></span>get_number_of_full_space_variables()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">unsigned int <a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::get_number_of_full_space_variables </td>
          <td>(</td>
          <td class="paramname"><span class="paramname"></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the number of internal network variables. </p>
<dl class="section return"><dt>Returns</dt><dd>returns number of internal variables </dd></dl>

</div>
</div>
<a id="a577ee52dca91fe4d987484afa8bf33a8" name="a577ee52dca91fe4d987484afa8bf33a8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a577ee52dca91fe4d987484afa8bf33a8">&#9670;&#160;</a></span>set_tanh_formulation()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::set_tanh_formulation </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45">TANH_REFORMULATION</a> &amp;</td>          <td class="paramname"><span class="paramname"><em>reformulation</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Changes the reformulation to be used for tanh evaluations. The reformulations are intended to be used when solvers do not support the tanh function. As reformulations change the tightness of the McCormick envelopes when used with MAiNGO it is recommended to use the standard tanh whenever possible. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">reformulation</td><td>enum representing the desired tanh reformulation </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a3b6e46ca8afad6af62b3f15e2b6b5ec6" name="a3b6e46ca8afad6af62b3f15e2b6b5ec6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3b6e46ca8afad6af62b3f15e2b6b5ec6">&#9670;&#160;</a></span>_annData</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::shared_ptr&lt;const <a class="el" href="structmelon_1_1_ann_data.html">AnnData</a>&gt; <a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::_annData</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a8d22eb1e65b7f74b4e84c3c8ea78df51" name="a8d22eb1e65b7f74b4e84c3c8ea78df51"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8d22eb1e65b7f74b4e84c3c8ea78df51">&#9670;&#160;</a></span>_inputScaler</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::unique_ptr&lt;<a class="el" href="classmelon_1_1_scaler.html">Scaler</a>&lt;T&gt; &gt; <a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::_inputScaler</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Object for scaling input data </p>

</div>
</div>
<a id="a25f7c656e140792b73fccc7058249256" name="a25f7c656e140792b73fccc7058249256"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a25f7c656e140792b73fccc7058249256">&#9670;&#160;</a></span>_outputScaler</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::unique_ptr&lt;<a class="el" href="classmelon_1_1_scaler.html">Scaler</a>&lt;T&gt; &gt; <a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::_outputScaler</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Object for scaling output data </p>

</div>
</div>
<a id="aa29c58f20ab3b344243565940fc0e243" name="aa29c58f20ab3b344243565940fc0e243"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa29c58f20ab3b344243565940fc0e243">&#9670;&#160;</a></span>_tanh_formulation</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">T(* <a class="el" href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a>&lt; T &gt;::_tanh_formulation) (T) = &amp;<a class="el" href="#acc52bba26e3affaf5bd8bdd97367130f">_tanh</a></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>pointer to the function used as formulation for the tanh </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>C:/Data/Git/MeLOn/feedforward neural network/model/inc/<a class="el" href="ff_net_8h_source.html">ffNet.h</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespacemelon.html">melon</a></li><li class="navelem"><a class="el" href="classmelon_1_1_feed_forward_net.html">FeedForwardNet</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.10.0 </li>
  </ul>
</div>
</body>
</html>
